<template>
  <div>
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Trainer Profile</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item">
                <a>Home</a>
              </li>
              <li class="breadcrumb-item active">Profile</li>
            </ol>
          </div>
        </div>
      </div>
      <!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-md-3">
            <!-- Profile Image -->
            <div class="card card-primary card-outline">
              <div class="card-body box-profile">
                <div class="text-center">
                  <img
                    class="profile-user-img img-fluid img-circle"
                    :src="trainer.image"
                    alt="User profile picture"
                  />
                </div>

                <h3 class="profile-username text-center">
                  {{ trainer.firstName }}
                </h3>

                <p class="text-muted text-center">Trainer</p>

                <ul class="list-group list-group-unbordered mb-3">
                  <li class="list-group-item">
                    <b>Clients</b>
                    <a class="float-right">{{ trainer.clientIds.length }}</a>
                  </li>
                  <li class="list-group-item">
                    <b>Email</b>
                    <div class="float-right">{{ trainer.email }}</div>
                  </li>
                </ul>

                <button
                  class="btn btn-primary btn-block"
                  @click="sendInviteLink"
                >
                  <b>Send client invite Email</b>
                </button>
              </div>
            </div>
          </div>
          <div class="col-md-9">
            <div class="card">
              <div class="card-header p-2">
                <ul class="nav nav-pills">
                  <li class="nav-item">
                    <a
                      class="nav-link"
                      v-bind:class="{ active: selectedTab === 'INFO' }"
                      v-on:click="selectedTab = 'INFO'"
                      >Info</a
                    >
                  </li>
                  <li
                    v-if="user.role === 'Admin'"
                    class="nav-item"
                    v-bind:class="{ active: selectedTab === 'SETTINGS' }"
                    v-on:click="selectedTab = 'SETTINGS'"
                  >
                    <a class="nav-link">Settings</a>
                  </li>
                </ul>
              </div>
              <div class="card-body">
                <div class="tab-content">
                  <div
                    class="tab-pane"
                    v-bind:class="{ active: selectedTab === 'INFO' }"
                  >
                    <form class="p-2">
                      <div class="form-row">
                        <div class="form-group col-sm-12">
                          <label>Bio</label>
                          <textarea
                            class="form-control"
                            :disabled="!editing"
                            v-model="editingTrainer.additionalInfo"
                          ></textarea>
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-12 col-md-4">
                          <label>First Name</label>
                          <input
                            type="text"
                            class="form-control"
                            :disabled="!editing"
                            v-model="editingTrainer.firstName"
                          />
                        </div>
                        <div class="form-group col-sm-12 col-md-4">
                          <label>Middle Name</label>
                          <input
                            type="text"
                            class="form-control"
                            :disabled="!editing"
                            v-model="editingTrainer.middleName"
                          />
                        </div>
                        <div class="form-group col-sm-12 col-md-4">
                          <label>Surname</label>
                          <input
                            type="text"
                            class="form-control"
                            :disabled="!editing"
                            v-model="editingTrainer.lastName"
                          />
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-12">
                          <label>Date of Birth</label>
                          <input
                            type="date"
                            class="form-control"
                            v-model="editingTrainer.dob"
                            :disabled="!editing"
                          />
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-12">
                          <label>Phone</label>
                          <input
                            :disabled="!editing"
                            type="text"
                            class="form-control"
                            v-model="editingTrainer.phone"
                          />
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-10">
                          <label>Address</label>
                          <input
                            :disabled="!editing"
                            type="text"
                            class="form-control"
                            v-model="editingTrainer.address"
                          />
                        </div>
                        <div class="form-group col-sm-2">
                          <label>Postal Code</label>
                          <input
                            :disabled="!editing"
                            type="text"
                            class="form-control"
                            v-model="editingTrainer.postalCode"
                          />
                        </div>
                      </div>

                      <hr />

                      <div class="d-flex flex-row-reverse">
                        <button
                          v-if="editing == true"
                          type="button"
                          class="btn btn-primary mr-2"
                          @click="editTrainer"
                        >
                          Update
                        </button>
                        <button
                          type="button"
                          class="btn btn-primary mr-2"
                          @click="toggleEdit"
                        >
                          {{ editing ? "Cancel" : "Edit" }}
                        </button>
                      </div>
                    </form>
                  </div>
                  <div
                    v-if="user.role === 'Admin'"
                    class="tab-pane"
                    v-bind:class="{ active: selectedTab === 'SETTINGS' }"
                  >
                    <div class="row">
                      <h3 class="h3">Disable</h3>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import userController from "../../controllers/user.controller";
import swal from "sweetalert2";
import auth from "../../controllers/auth.controller";
export default {
  name: "TrainerProfile",
  computed: {
    user() {
      return this.$store.getters.getAuthUser;
    },
  },
  data() {
    return {
      editing: false,
      selectedTab: "INFO",
      editingTrainer: {},
    };
  },
  props: ["trainer"],
  methods: {
    toggleEdit() {
      if (this.editing) {
        this.editing = false;
        this.editingTrainer = this.user;
      } else {
        this.editing = true;
      }
    },
    async editTrainer() {
      try {
        const resposne = await userController.updateTrainer(
          this.editingTrainer
        );
        if (resposne.status === 204) {
          swal.fire({
            icon: "success",
            title: "Profile updated!",
          });

          const newTrainer = await (
            await userController.getTrainer(this.trainer.trainerId)
          ).data;

          this.trainer = newTrainer;
          this.editingUser = { ...newTrainer };
          this.editing = false;
        }
      } catch (e) {
        swal.fire({
          icon: "error",
          title: `Oops... ${e.resposne ? e.resposne.status : ""}`,
          text: "An error occured, please try again!",
        });
      }
    },
    async sendInviteLink() {
      const result = await swal.fire({
        title: "Client email",
        input: "email",
        inputAttributes: {
          autocapitalize: "off",
        },
        showCancelButton: true,
        confirmButtonText: "Send",
        showLoaderOnConfirm: true,
        preConfirm: async (email) => {
          try {
            await auth.sendInviteLink(email, this.trainer.trainerId);
          } catch (e) {
            swal.fire("Registration already sent to this mail", "", "warning");
          }
        },
        allowOutsideClick: () => !swal.isLoading(),
      });
      if (result.value) {
        swal.fire({
          icon: "success",
          title: "Email sent!",
        });
      }
    },
  },
  mounted() {
    this.editingTrainer = { ...this.trainer };
    this.editingTrainer.dob = this.editingTrainer.dob.split("T")[0];
  },
};
</script>

<style>
.nav-link.active:hover {
  color: white !important;
}
</style>